/*
 * $Id: encode_sun.h,v 1.1 1997/02/28 14:02:54 tommy Exp $
 */

#ifndef _ENCODE_SUN_H
#define _ENCODE_SUN_H

#include <sys/types.h>

#define SUNAUDIO_MAGIC        '.snd'
#define SUNAUDIO_UNKNOWN_SIZE ((unsigned)(~0))

#define SUNAUDIO_ENCODING_MULAW_8   1     /* ISDN u-law                    */
#define SUNAUDIO_ENCODING_LINEAR_8  2     /* ISDN A-law                    */
#define SUNAUDIO_ENCODING_LINEAR_16 3     /* PCM 2's-complement (0-center) */
#define SUNAUDIO_ENCODING_LINEAR_24 4     /* PCM 2's-complement (0-center) */
#define SUNAUDIO_ENCODING_LINEAR_32 5     /* PCM 2's-complement (0-center) */
#define SUNAUDIO_ENCODING_FLOAT     6     /* IEEE float  (-1. <-> +1.)     */
#define SUNAUDIO_ENCODING_DOUBLE    7     /* IEEE double (-1. <-> +1.)     */

#define SUNAUDIO_HDR_SIZE     32          /* except infomation record      */

typedef struct {
    u_int32_t magic;                      /* ".snd" */
    u_int32_t head_length;
    u_int32_t data_length;                /* unknown = ~0 */
    u_int32_t data_format;
    u_int32_t sample_rate;
    u_int32_t channels;
    char      *infop;
} sun_header_t;

#endif /* _ENCODE_SUN_H */
