/*
 * $Id: play.h,v 1.8 1997/03/26 14:20:38 tommy Exp $
 */

#ifndef _PLAY_H
#define _PLAY_H

#include <sys/types.h>

#include "encode_riff.h"
#include "encode_sun.h"

#define TRUE  (1 == 1)
#define FALSE !TRUE

#define FAIL     -1
#define SUCCESS  0

typedef enum {type_unknown, type_ulaw, type_wav} encode_t;

extern char *myname;
extern int  intr;

extern int  f_verbose;
extern int  f_extra;

extern int  f_hasdsp;
extern int  f_spd_spc;

extern int intr;

#define DEV_MIXER "/dev/mixer"
#define DEV_DSP   "/dev/dsp"
#define DEV_PC    "/dev/pcaudio"

#define UNKNOWN -1
#define BYTE     1
#define WORD     2
#define LONG     4

typedef struct {
    char *device;
    int  format;
    int  volume;
    int  bass;
    int  treble;
    int  speed;
} arg_params_t;



void           reset_signal(void);
void           intr_play(int);
int            check_numarg(char *, char);
int            is_num_str(const char *);
int            set_mixer(arg_params_t *);
int            set_speed(int, int);
int            play_audio(char *, arg_params_t *);
encode_t       audio_type(char *, size_t);
arg_params_t  *init_params(arg_params_t *);
riff_header_t *check_riff(char *);
int            play_riff(char *, riff_header_t *, arg_params_t *);
sun_header_t  *check_sunaudio(char *);
int            play_sunaudio(char *, sun_header_t *, arg_params_t *);

#endif /* _PLAY_H */
