#ifndef lint
static char rcsid[] =
"$Id: play_audio.c,v 1.7 1997/03/26 14:20:52 tommy Exp $";
#endif

#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <err.h>
#include <machine/soundcard.h>

#include "play.h"
#include "encode_riff.h"
#include "encode_sun.h"

void intr_play(int x)
{
    intr = FALSE;
}

int play_audio(char *audio_file, arg_params_t *params)
{
    riff_header_t *riff_headerp;
    sun_header_t *sunaudio_headerp;
    int (*player)(char *, void *, arg_params_t *);
    void *header;

    if (params->device != NULL && strcmp(params->device, DEV_PC) == 0)
	f_hasdsp = FALSE;
    
    if (f_hasdsp && set_mixer(params))
	err(1, "Cannot change mixer");

    if ((riff_headerp = check_riff(audio_file)) != NULL) {
        if (riff_headerp == (riff_header_t*)FAIL)
            return FAIL;
	player = play_riff;
	header = (riff_header_t *)riff_headerp;
    } else if ((sunaudio_headerp = check_sunaudio(audio_file)) != NULL) {
        if (sunaudio_headerp == (sun_header_t*)FAIL)
            return FAIL;
	player = play_sunaudio;
	header = (sun_header_t *) sunaudio_headerp;
    } else {
        fprintf(stderr, "%s: %s: Unknown format.\n", myname, audio_file);
        return SUCCESS;
    }

    player(audio_file, header, params);

    return SUCCESS;
}
